<template>
  <v-card
    class="mx-auto"
    outlined
  >
    <v-form class="my-7">
      <v-row no-gutters justify="center">
        <v-col cols="4">
          <v-text-field
            v-model="description"
            label="Descripción"
            :rules="descriptionRules"
            counter="50"
            required
            outlined
          />
          <v-text-field
            v-model.number="totalCapacity"
            label="Capacidad total"
            :rules="totalCapacityRules"
            suffix="pallets"
            type="number"
            required
            outlined
          />
          <v-select
            v-model="centerId"
            :items="centers"
            item-value="id"
            item-text="name"
            label="Centro de Distribución"
            outlined
          />
          <option-btns
            @cancel="returnToAreas"
            @register="registerAndReturn"
          />
        </v-col>
      </v-row>
    </v-form>
  </v-card>
</template>

<script>
import { mapActions, mapState } from 'vuex';
import OptionBtns from '~/components/Common/Form/OptionBtns';
import { errorOptions, successOptions } from '~/helpers/toast';

export default {
  name: 'NewAreaForm',
  components: {
    OptionBtns,
  },
  data: () => ({
    description: '',
    totalCapacity: '',
    centerId: null,
    emailRules: [],
    descriptionRules: [],
    totalCapacityRules: [],
  }),
  computed: {
    ...mapState({
      centers: state => state.storage.areas.availableCenters,
    }),
  },
  async mounted() {
    await this.getAllAvailableCenters();
  },
  methods: {
    ...mapActions({
      registerNewArea: 'storage/areas/registerNewArea',
      getAllCenters: 'storage/areas/getAllCenters',
    }),
    async getAllAvailableCenters() {
      try {
        await this.getAllCenters();
      } catch (e) {
        console.error(e);
      }
    },
    returnToAreas() {
      this.$router.push('/almacenamiento/zonas');
    },
    async registerAndReturn() {
      try {
        const { description, totalCapacity, centerId } = this;
        await this.registerNewArea({ description, totalCapacity, centerId });
        this.$toast.success('Se ha registrado la nueva zona correctamente', successOptions);
        await this.returnToAreas();
      } catch (e) {
        this.$toast.error('No se ha podido registrar la nueva zona', errorOptions);
      }
    },
  },
};
</script>
